Summary: PostgreSQL Data Base Management System 
Name: postgresql
Version: 6.4
Release: 1
Group: Applications/Databases
Copyright: BSD
Url: http://www.postgresql.org/
Packager: Hao Li <hli@wag.caltech.edu>
Source: ftp://ftp.postgresql.org/pub/postgresql-v%{version}.tar.gz
Source1: postgresql.init
Patch: postgresql-v6.4.patch
Requires: postgresql-clients
Buildroot: /var/tmp/%{name}-root

%description
PostgreSQL Data Base Management System (formerly known as Postgres, then as
Postgres95). 

PostgreSQL is an enhancement of the POSTGRES database management system, a
next-generation DBMS research prototype.  While PostgreSQL retains the
powerful data model and rich data types of POSTGRES, it replaces the PostQuel
query language with an extended subset of SQL. PostgreSQL is free and the
complete source is available. 

PostgreSQL development is being performed by a team of Internet developers who
all subscribe to the PostgreSQL development mailing list. The current
coordinator is Marc G. Fournier (scrappy@postgreSQL.org). This team is now
responsible for all current and future development of PostgreSQL. 

The authors of PostgreSQL 1.01 were Andrew Yu and Jolly Chen. Many others have
contributed to the porting, testing, debugging and enhancement of the code.
The original Postgres code, from which PostgreSQL is derived, was the effort
of many graduate students, undergraduate students, and staff programmers
working under the direction of Professor Michael Stonebraker at the University
of California, Berkeley. 

The original name of the software at Berkeley was Postgres. When SQL
functionality was added in 1995, its name was changed to Postgres95. The name
was changed at the end of 1996 to PostgreSQL. 

PostgreSQL runs on Solaris, SunOS, HPUX, AIX, Linux, Irix, FreeBSD, and most
flavours of Unix. 


%package devel
Summary: PostgreSQL development header files and libraries
Group: Development/Libraries
Requires: postgresql-clients

%description devel
This package contains header files and libraries required to compile
applications that are talking directly to the PostgreSQL backend server. 


%package clients
Summary: clients needed to access a PostgreSQL server
Group: Applications/Databases

%description clients
This package includes only the clients and client libraries needed to access
an PostgreSQL server. The server is included in the main package. If all you
need is to connect to another PostgreSQL server, the  this is the only
package you need to install.

In this package there are client libraries available for C, C++ and PERL, as
well as several command-line utilities you can use to manage your databases
on a remote PostgreSQL server.


%prep
%setup -q -n %{name}-v%{version}
%patch


%build
cd src
CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=/usr \
	--with-template=linux_i386 \
	--with-tcl --with-x
make HAVE_Cplusplus=true all
cd ..

# Unpack documentations
make -C doc all PGDOCS=unpacked


%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/{include/pgsql,lib,bin}

make -C src HAVE_Cplusplus=true POSTGRESDIR=$RPM_BUILD_ROOT/usr install

# Move all includes beneath /usr/include/pgsql.
( cd $RPM_BUILD_ROOT/usr/include
  for f in *; do
  	if [ $f != "pgsql" ]; then mv $f pgsql; fi
  done
)

# Move all templates/examples beneath /usr/lib/pgsql
( cd $RPM_BUILD_ROOT/usr/lib
  mkdir pgsql
  mv *source *sample *description pgsql
)

# Fix permissions of shared objects to make ldd happy:
chmod 755 $RPM_BUILD_ROOT/usr/lib/{lib*.so.*,pl*.so}

# Install man pages
make -C doc POSTGRESDIR=$RPM_BUILD_ROOT/usr man

# Install daemon script
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
install -m 755 $RPM_SOURCE_DIR/postgresql.init \
	$RPM_BUILD_ROOT/etc/rc.d/init.d/postgresql

# Strip 'em all
strip $RPM_BUILD_ROOT/usr/bin/* || :


%postun
chkconfig --del postgresql


%post   -p /sbin/ldconfig clients
%postun -p /sbin/ldconfig clients


%files
%defattr(-,root,root)
%config /etc/rc.d/init.d/*
%doc COPYRIGHT HISTORY INSTALL README register.txt
%doc contrib doc/unpacked/*
%doc doc/FAQ* doc/README* doc/TODO doc/*.ps.gz doc/bug.template
/usr/lib/pgsql
/usr/man/man5/*
/usr/bin/cleardbdir
/usr/bin/createdb
/usr/bin/createuser
/usr/bin/destroydb
/usr/bin/destroyuser
/usr/bin/initdb
/usr/bin/initlocation
/usr/bin/ipcclean
/usr/bin/pg_passwd
/usr/bin/pg_upgrade
/usr/bin/pg_version
/usr/bin/postgres
/usr/bin/postmaster
/usr/man/man1/cleardbdir.1
/usr/man/man1/createdb.1
/usr/man/man1/createuser.1
/usr/man/man1/destroydb.1
/usr/man/man1/destroyuser.1
/usr/man/man1/initdb.1
/usr/man/man1/initlocation.1
/usr/man/man1/ipcclean.1
/usr/man/man1/pg_passwd.1
/usr/man/man1/pg_upgrade.1
/usr/man/man1/postgres.1
/usr/man/man1/postmaster.1

%files devel
%defattr(-,root,root)
/usr/include/*
/usr/lib/*.a
/usr/lib/*.so
/usr/man/man3/*
/usr/bin/ecpg
/usr/man/man1/ecpg.1

%files clients
%defattr(-,root,root)
/usr/lib/*.so.*
/usr/man/manl/*
/usr/bin/pg_dump
/usr/bin/pg_dumpall
/usr/bin/pg_id
/usr/bin/pgtclsh
/usr/bin/pgtksh
/usr/bin/psql
/usr/man/man1/pg_dump.1
/usr/man/man1/pg_dumpall.1
/usr/man/man1/psql.1


%clean
rm -rf $RPM_BUILD_ROOT


%changelog
* Wed Nov 25 1998 Hao Li <hli@wag.caltech.edu>
- Based on RedHat 5.2 stock version of postgresql-6.3.2-10. 
  Differences:
  1. Perl interface removed because it is too dirty. Will resurrect
     when I need it or when it is cleaned up.
  2. pgaccess removed and made standalone so that I can upgrade pgaccess
     without touching postgresql.
  3. postgresql-data removed. Including them in RPM will necessitate 
     building as root, which I would not see. Initial database can be
     created manually.
  4. User postgresql is left to be created by RPM for now. Actually I am 
     also thinking of making it manual since I would like to control UID
     of postgresql rather letting "useradd" to choose it automatically.
